#include "uart1.h"

CHANNEL channel[MAX_CHANNELS];

/* USART Parser Variablen */
char command[80];
uint16_t fpar = 0;
uint8_t fchan = 0;
bool all_chan = false;
uint8_t cnt = 0;

volatile UART g_uart;
volatile char received_string[MAX_STRLEN+1]; // this will hold the recieved string

//uint8_t control_type = TWI_CONNECTION;

void init_USART1(uint32_t baudrate)
{
	GPIO_InitTypeDef GPIO_InitStructure;
	USART_InitTypeDef USART_InitStructure;
	NVIC_InitTypeDef NVIC_InitStructure;
	
	/* Clock configuration -------------------------------------------------------*/
	RCC_APB2PeriphClockCmd(RCC_APB2Periph_USART1, ENABLE);
	RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOA, ENABLE);
	RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOC, ENABLE);
	
	NVIC_PriorityGroupConfig(NVIC_PriorityGroup_4);
 
	NVIC_InitStructure.NVIC_IRQChannel = USART1_IRQn;
	NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;
	NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = 0x0F;
	NVIC_InitStructure.NVIC_IRQChannelSubPriority = 0x0F;
	NVIC_Init(&NVIC_InitStructure);
	
	GPIO_PinRemapConfig(GPIO_Remap_USART1, ENABLE);

	/* Configure the GPIO ports( USART1 Transmit and Receive Lines) */
	/* Configure the USART1_Tx as Alternate function Push-Pull */
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF_PP;
	GPIO_InitStructure.GPIO_Pin =  GPIO_Pin_9;
	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
	GPIO_Init(GPIOA, &GPIO_InitStructure);

	/* Configure the USART1_Rx as input floating */
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IN_FLOATING;
	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_10 ;
	GPIO_Init(GPIOA, &GPIO_InitStructure);

	/* USART1 configuration ------------------------------------------------------*/
	/* USART1 configured as follow:
	- BaudRate = like parameter (115200kbps)  
	- Word Length = 8 Bits
	- One Stop Bit
	- No parity
	- Hardware flow control disabled (RTS and CTS signals)
	- Receive and transmit enabled
	*/
	USART_InitStructure.USART_BaudRate = baudrate;
	USART_InitStructure.USART_WordLength = USART_WordLength_8b;
	USART_InitStructure.USART_StopBits = USART_StopBits_1;
	USART_InitStructure.USART_Parity = USART_Parity_No;
	USART_InitStructure.USART_HardwareFlowControl = USART_HardwareFlowControl_None;
	USART_InitStructure.USART_Mode = USART_Mode_Rx | USART_Mode_Tx;

	USART_DeInit(USART1);

	/* Configure the USART1 */
	USART_Init(USART1, &USART_InitStructure);

	/* Enable USART1 interrupt */
	USART_ITConfig(USART1, USART_IT_RXNE, ENABLE);
	//USART_ITConfig(USART1, USART_IT_TXE,ENABLE);
	
	/* Enable the USART1 */
	USART_Cmd(USART1, ENABLE);
  
	g_uart.NewCommand = 0;
}

void Usart1Put(uint8_t ch)
{
      USART_SendData(USART1, (uint8_t) ch);
      //Loop until the end of transmission
      while(USART_GetFlagStatus(USART1, USART_FLAG_TC) == RESET)
      {
      }
}

uint8_t Usart1Get(void)
{
     while ( USART_GetFlagStatus(USART1, USART_FLAG_RXNE) == RESET);
        return (uint8_t)USART_ReceiveData(USART1);
}

void USART_puts(volatile char *s)
{

  while(*s){
    // wait until data register is empty
    while( !(USART1->SR & 0x00000040) ); 
    USART_SendData(USART1, *s);
    *s++;
  }
}

int getNewCommand(void)
{
  return g_uart.NewCommand;
}

char *getCommand(void)
{
  g_uart.NewCommand = 0;
  return (char *)g_uart.Command;
}

void parseCommands( void )
{
    if (getNewCommand() == 1) { // && isAtMode() == 0) {
			if ((strcmp(getCommand(),"h") == 0)) { // && control_type == BLUETOOTH_CONNECTION) {
				d_printArray();
            }
        }
}

// this is the interrupt request handler (IRQ) for ALL USART1 interrupts
void USART1_IRQHandler(void){
  
  // check if the USART1 receive interrupt flag was set
  if( USART_GetITStatus(USART1, USART_IT_RXNE) ){
    char t = USART1->DR; // the character from the USART1 data register is saved in t
    
    if (t != '\r') {
        if (g_uart.CommandCount<(MAXCOMMANDSCHARS-1)) {
        // Befehl zusammenbauen und mit Null abschliessen
        g_uart.Command[g_uart.CommandCount] = t;
        g_uart.Command[++(g_uart.CommandCount)] = '\0';
        }
      }
      else {
        g_uart.NewCommand = 1;
        g_uart.CommandCount = 0;
    }
  }
}

